(***********************************************************************)
(*                                                                     *)
(*                          OCamlP3l                                   *)
(*                                                                     *)
(* (C) 2004-2006                                                       *)
(*             Roberto Di Cosmo (dicosmo@dicosmo.org)                  *)
(*             Zheng Li (zli@lip6.fr)                                  *)
(*             Pierre Weis (Pierre.Weis@inria.fr)                      *)
(*             Francois Clement (Francois.Clement@inria.fr)            *)
(*                                                                     *)
(* Based on original Ocaml P3L System                                  *)
(* (C) 1997 by                                                         *)
(*             Roberto Di Cosmo (dicosmo@ens.fr)                       *)
(*             Marco Danelutto (marcod@di.unipi.it)                    *)
(*             Xavier Leroy  (Xavier.Leroy@inria.fr)                   *)
(*             Susanna Pelagatti (susanna@di.unipi.it)                 *)
(*                                                                     *)
(* This program is free software; you can redistribute it and/or       *)
(* modify it under the terms of the GNU Library General Public License *)
(* as published by the Free Software Foundation; either version 2      *)
(* of the License, or (at your option) any later version.              *)
(*                                                                     *)
(* This program is distributed in the hope that it will be useful,     *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of      *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *)
(* GNU Library General Public License for more details.                *)
(*                                                                     *)
(***********************************************************************)

(* $Id: p3l.mli,v 1.2 2007/01/12 21:08:29 weis Exp $ *)

(* This is the signature of the P3l skeleton algebra, which is shared by all
   the operational semantics. *)

type color = P3lstream.color;;

type ('a, 'b) skel;;

val seq : ?col:color -> (unit -> 'a -> 'b) -> ('a, 'b) skel;;

val pipeline : ('a, 'b) skel -> ('b, 'c) skel -> ('a, 'c) skel;;

val ( ||| ) : ('a, 'b) skel -> ('b, 'c) skel -> ('a, 'c) skel;;

val farm :
  ?col:color -> ?colv:color list -> ('a, 'b) skel * int -> ('a, 'b) skel;;

val mapvector :
  ?col:color -> ?colv:color list ->
  ('a, 'b) skel * int -> ('a array, 'b array) skel;;

val reducevector :
  ?col:color -> ?colv:color list ->
  ('a * 'a, 'a) skel * int -> ('a array, 'a) skel;;

val loop : ?col:color -> ('a -> bool) * ('a, 'a) skel -> ('a, 'a) skel;;

val parfun : (unit -> ('a, 'b) skel) -> 'a P3lstream.s -> 'b P3lstream.s;;

val pardo : (unit -> unit) -> unit;;
